"""
Common resource for nerve centreline annotation terms.
"""

# convention: preferred name, preferred id, followed by any other ids and alternative names

nerve_terms = [
    ('C3_C5_spinal_n-phrenic_n', ''),
    ('C3_dorsal_root_end', ''),
    ('C3_spinal', ''),
    ('C3_ventral_root_end', ''),
    ('C4_dorsal_root_end', ''),
    ('C4_spinal', ''),
    ('C4_ventral_root_end', ''),
    ('C5_dorsal_root_end', ''),
    ('C5_spinal', ''),
    ('C5_ventral_root_end', ''),
    ('C6_dorsal_root_end', ''),
    ('C6_spinal', ''),
    ('C7_dorsal_root_end', ''),
    ('C7_spinal', ''),
    ('C8_dorsal_root_end', ''),
    ('C8_spinal', ''),
    ('Gray communicating ramus', 'FMA:5876'),
    ('L1_dorsal_root_end', ''),
    ('L1_spinal', ''),
    ('L1_ventral_root_end', ''),
    ('L2_dorsal_root_end', ''),
    ('L2_spinal', ''),
    ('L2_ventral_root_end', ''),
    ('L5_spinal', ''),
    ('L5_ventral_root_end', ''),
    ('L6_dorsal_root_end', ''),
    ('L6_spinal', ''),
    ('L6_ventral_root_end', ''),
    ('Laryngeal mechanoreceptors', 'ILX:0738317'),
    ('S1_dorsal_root_end', ''),
    ('S1_spinal', ''),
    ('S1_ventral_root_end', ''),
    ('S43_L1', ''),
    ('S43_L2', ''),
    ('S43_L6', ''),
    ('S43_S1', ''),
    ('S45_L1', ''),
    ('S45_L2', ''),
    ('S45_L6', ''),
    ('S45_S1', ''),
    ('S46_L1', ''),
    ('S46_L2', ''),
    ('S48_L1', ''),
    ('S48_L2', ''),
    ('S49_L1', ''),
    ('S49_L2', ''),
    ('S50_C3_B', ''),
    ('S50_C4_B', ''),
    ('S50_C5_B', ''),
    ('S50_C6_B', ''),
    ('S50_C7_B', ''),
    ('S50_C8_B', ''),
    ('S50_L1', ''),
    ('S50_L2', ''),
    ('S50_T1', ''),
    ('S50_T10', ''),
    ('S50_T11', ''),
    ('S50_T12', ''),
    ('S50_T13', ''),
    ('S50_T2', ''),
    ('S50_T3', ''),
    ('S50_T4', ''),
    ('S50_T5', ''),
    ('S50_T6', ''),
    ('S50_T7', ''),
    ('S50_T8', ''),
    ('S50_T9', ''),
    ('T10_spinal', ''),
    ('T10_ventral_root_end', ''),
    ('T11_spinal', ''),
    ('T11_ventral_root_end', ''),
    ('T12_spinal', ''),
    ('T12_ventral_root_end', ''),
    ('T13_spinal', ''),
    ('T13_ventral_root_end', ''),
    ('T1_dorsal_root_end', ''),
    ('T1_spinal', ''),
    ('T1_ventral_root_end', ''),
    ('T2_dorsal_root_end', ''),
    ('T2_spinal', ''),
    ('T2_ventral_root_end', ''),
    ('T3_dorsal_root_end', ''),
    ('T3_spinal', ''),
    ('T3_ventral_root_end', ''),
    ('T4_dorsal_root_end', ''),
    ('T4_spinal', ''),
    ('T4_ventral_root_end', ''),
    ('T5_dorsal_root_end', ''),
    ('T5_spinal', ''),
    ('T5_ventral_root_end', ''),
    ('T6_dorsal_root_end', ''),
    ('T6_spinal', ''),
    ('T6_ventral_root_end', ''),
    ('T7_spinal', ''),
    ('T7_ventral_root_end', ''),
    ('T8_spinal', ''),
    ('T8_ventral_root_end', ''),
    ('T9_spinal', ''),
    ('T9_ventral_root_end', ''),
    ('Wall of larynx', 'ILX:0738326'),
    ('White communicating ramus', 'FMA:5875'),
    ('ardell_1_branching_point', ''),
    ('ardell_1_start-1', ''),
    ('ardell_1_start-2', ''),
    ('ardell_1_start-3', ''),
    ('ardell_1_start-4', ''),
    ('ardell_1_start-5', ''),
    ('ardell_1_start-6', ''),
    ('ardell_1_start-7', ''),
    ('ardell_1_start-8', ''),
    ('ardell_1_start-9', ''),
    ('ardell_2_branching_point', ''),
    ('ardell_2_start', ''),
    ('ardell_3_branching_point', ''),
    ('ardell_4_branching_point', ''),
    ('ardell_5_branching_point', ''),
    ('ardell_5_start-1', ''),
    ('ardell_5_start-2', ''),
    ('ardell_5_start-3', ''),
    ('ardell_5_start-4', ''),
    ('ardell_5_start-5', ''),
    ('ardell_5_start-6', ''),
    ('ardell_6_branching_point', ''),
    ('ardell_6_start-1', ''),
    ('ardell_6_start-2', ''),
    ('ardell_6_start-3', ''),
    ('ardell_6_start-4', ''),
    ('ardell_6_start-5', ''),
    ('ardell_6_start-6', ''),
    ('ardell_6_start-7', ''),
    ('ardell_6_start-8', ''),
    ('ardell_6_start-9', ''),
    ('aryepiglottic fold', 'UBERON:0014385'),
    ('back part of the tongue*', 'UBERON:0010033'),
    ('bladder_n-bladder', ''),
    ('bolser_14-1', ''),
    ('bolser_1_branching_point', ''),
    ('bolser_6_branching_point', ''),
    ('bolser_8_branching_point', ''),
    ('bolser_9-2', ''),
    ('bolser_9_branching_point', ''),
    ('bronchus smooth muscle', 'UBERON:0004242'),
    ('cardiac nerve plexus', 'UBERON:0002008'),
    ('carotid body', 'UBERON:0001629'),
    ('ceratocricoid ligament', 'FMA:77283'),
    ('connection_1-1', ''),
    ('cricothyroid muscle', 'UBERON:0001566'),
    ('dorsal motor nucleus of vagus nerve', 'UBERON:0002870'),
    ('dorsal root ganglion', 'UBERON:0000044'),
    ('dorsal root of spinal cord', 'UBERON:0002261'),
    ('epiglottic vallecula', 'UBERON:0013165'),
    ('epiglottis', 'UBERON:0000388'),
    ('esophageal nerve plexus', 'FMA:6225'),
    ('external carotid nerve plexus', 'FMA:67532'),
    ('external_laryngeal_n_branching_point', ''),
    ('glossopharyngeal ganglion', 'UBERON:0001701'),
    ('hypogastric nerve', 'UBERON:0005303'),
    ('inferior mesenteric ganglion', 'UBERON:0005453'),
    ('inferior pharyngeal constrictor', 'UBERON:0001570'),
    ('inferior vagus X ganglion', 'UBERON:0005363'),
    ('internal carotid nerve plexus', 'UBERON:0002024'),
    ('keast_1-1', ''),
    ('kidney', 'UBERON:0002113'),
    ('label_1-1', ''),
    ('label_11-1', ''),
    ('label_12-1', ''),
    ('label_13-1', ''),
    ('label_2-1', ''),
    ('label_3-1', ''),
    ('lateral crico-arytenoid', 'UBERON:0008573'),
    ('left gastric nerve plexus', 'FMA:6633'),
    ('lumbar splanchnic nerve', 'UBERON:0018683'),
    ('lumbar_splanchnic_n_start', ''),
    ('mucosa of larynx', 'UBERON:0001824'),
    ('mucosa of pharynx', 'FMA:55031'),
    ('nucleus ambiguus', 'UBERON:0001719'),
    ('nucleus of solitary tract', 'UBERON:0009050'),
    ('oblique arytenoid', 'UBERON:0008575'),
    ('pancreas', 'UBERON:0001264'),
    ('paravertebral ganglion', 'UBERON:0001807'),
    ('pelvic ganglion', 'UBERON:0016508'),
    ('pelvic splanchnic nerve', 'UBERON:0018675'),
    ('pelvic_splanchnic_n_start', ''),
    ('pharyngeal nerve plexus', 'UBERON:0011325'),
    ('pharynx', 'UBERON:0006562'),
    ('phrenic_n_branching_point', ''),
    ('point_1', ''),
    ('point_10', ''),
    ('point_11', ''),
    ('point_12', ''),
    ('point_13', ''),
    ('point_14', ''),
    ('point_15', ''),
    ('point_16', ''),
    ('point_17', ''),
    ('point_18', ''),
    ('point_19', ''),
    ('point_2', ''),
    ('point_20', ''),
    ('point_21', ''),
    ('point_22', ''),
    ('point_23', ''),
    ('point_24', ''),
    ('point_25', ''),
    ('point_26', ''),
    ('point_27', ''),
    ('point_28', ''),
    ('point_29', ''),
    ('point_3', ''),
    ('point_30', ''),
    ('point_31', ''),
    ('point_32', ''),
    ('point_33', ''),
    ('point_34', ''),
    ('point_35', ''),
    ('point_36', ''),
    ('point_37', ''),
    ('point_38', ''),
    ('point_4', ''),
    ('point_40', ''),
    ('point_41', ''),
    ('point_42', ''),
    ('point_5', ''),
    ('point_6', ''),
    ('point_7', ''),
    ('point_8', ''),
    ('point_9', ''),
    ('posterior crico-arytenoid', 'UBERON:0008572'),
    ('pudendal nerve', 'UBERON:0011390'),
    ('pudendal_n_branching_point', ''),
    ('pudendal_n_start', ''),
    ('pulmonary nerve plexus', 'UBERON:0002009'),
    ('spinal nerve', 'UBERON:0001780'),
    ('splanchnic_n_branching_point', ''),
    ('splanchnic_n_start-1', ''),
    ('splanchnic_n_start-10', ''),
    ('splanchnic_n_start-11', ''),
    ('splanchnic_n_start-12', ''),
    ('splanchnic_n_start-13', ''),
    ('splanchnic_n_start-14', ''),
    ('splanchnic_n_start-2', ''),
    ('splanchnic_n_start-3', ''),
    ('splanchnic_n_start-4', ''),
    ('splanchnic_n_start-5', ''),
    ('splanchnic_n_start-6', ''),
    ('splanchnic_n_start-7', ''),
    ('splanchnic_n_start-8', ''),
    ('splanchnic_n_start-9', ''),
    ('superior cervical ganglion', 'UBERON:0001989'),
    ('superior vagus X ganglion', 'UBERON:0005364'),
    ('sympathetic trunk', 'UBERON:0000407'),
    ('thyro-arytenoid', 'FMA:46588'),
    ('transverse arytenoid', 'UBERON:0008574'),
    ('trigeminal nucleus', 'UBERON:0002925'),
    ('tympanic membrane', 'UBERON:0002364'),
    ('ventral root of spinal cord', 'UBERON:0002260'),
    ('vocalis muscle', 'UBERON:0008577'),
    # flatmap centrelines
    ('C3_dorsal_root', ''),
    ('C3_spinal_n', ''),
    ('C3_ventral_root', ''),
    ('C4_dorsal_root', ''),
    ('C4_spinal_n', ''),
    ('C4_ventral_root', ''),
    ('C5_dorsal_root', ''),
    ('C5_spinal_n', ''),
    ('C5_ventral_root', ''),
    ('C6_dorsal_root', ''),
    ('C6_spinal_n', ''),
    ('C7_dorsal_root', ''),
    ('C7_spinal_n', ''),
    ('C8_dorsal_root', ''),
    ('C8_spinal_n', ''),
    ('External branch of inferior laryngeal nerve', 'ILX:0738308'),
    ('External branch of superior laryngeal nerve', 'ILX:0738374'),
    ('Ganglioglomerular nerve', 'ILX:0738293'),
    ('ICG-CTG_sympathetic_cord', ''),
    ('ICG-ardell_2', ''),
    ('ICG-ardell_6', ''),
    ('Internal branch of inferior laryngeal nerve', 'ILX:0738309'),
    ('Internal branch of superior laryngeal nerve', 'ILX:0738373'),
    ('L1_dorsal_root', ''),
    ('L1_spinal_n-1', ''),
    ('L1_spinal_n-2', ''),
    ('L1_ventral_root_paravertebral_ganglion', ''),
    ('L1_ventral_root_ramus', ''),
    ('L2_dorsal_root', ''),
    ('L2_spinal_n', ''),
    ('L2_ventral_root_paravertebral_ganglion', ''),
    ('L2_ventral_root_ramus', ''),
    ('L5_spinal_n', ''),
    ('L5_ventral_root', ''),
    ('L6_dorsal_root', ''),
    ('L6_paravertebral_ganglion', ''),
    ('L6_spinal_n-1', ''),
    ('L6_spinal_n-2', ''),
    ('L6_ventral_root', ''),
    ('MCG-ICG_sympathetic_cord', ''),
    ('MCG-ardell_2', ''),
    ('MCG-ardell_6', ''),
    ('S1_dorsal_root', ''),
    ('S1_paravertebral_ganglion', ''),
    ('S1_spinal_n-1', ''),
    ('S1_spinal_n-2', ''),
    ('S1_ventral_root', ''),
    ('SCG-MCG_sympathetic_cord', ''),
    ('SCG-ardell_6', ''),
    ('T10_spinal_n-3', ''),
    ('T10_ventral_root_ramus', ''),
    ('T11_spinal_n-3', ''),
    ('T11_ventral_root_ramus', ''),
    ('T12_spinal_n-3', ''),
    ('T12_ventral_root_ramus', ''),
    ('T13_spinal_n-3', ''),
    ('T13_ventral_root_ramus', ''),
    ('T1_dorsal_root', ''),
    ('T1_gray_ramus-spinal_n', ''),
    ('T1_paravertebral_ganglion-ardell_5', ''),
    ('T1_spinal_n-1', ''),
    ('T1_spinal_n-2', ''),
    ('T1_spinal_n-3', ''),
    ('T1_ventral_root_paravertebral_ganglion', ''),
    ('T1_ventral_root_ramus', ''),
    ('T2_dorsal_root', ''),
    ('T2_gray_ramus-spinal_n', ''),
    ('T2_paravertebral_ganglion-ardell_5', ''),
    ('T2_spinal_n-1', ''),
    ('T2_spinal_n-2', ''),
    ('T2_spinal_n-3', ''),
    ('T2_ventral_root_paravertebral_ganglion', ''),
    ('T2_ventral_root_ramus', ''),
    ('T3_dorsal_root', ''),
    ('T3_gray_ramus-spinal_n', ''),
    ('T3_paravertebral_ganglion-ardell_5', ''),
    ('T3_spinal_n-1', ''),
    ('T3_spinal_n-2', ''),
    ('T3_spinal_n-3', ''),
    ('T3_ventral_root_paravertebral_ganglion', ''),
    ('T3_ventral_root_ramus', ''),
    ('T4_dorsal_root', ''),
    ('T4_gray_ramus-spinal_n', ''),
    ('T4_paravertebral_ganglion-ardell_5', ''),
    ('T4_spinal_n-1', ''),
    ('T4_spinal_n-2', ''),
    ('T4_spinal_n-3', ''),
    ('T4_ventral_root_paravertebral_ganglion', ''),
    ('T4_ventral_root_ramus', ''),
    ('T5_dorsal_root', ''),
    ('T5_gray_ramus-spinal_n', ''),
    ('T5_paravertebral_ganglion-ardell_5', ''),
    ('T5_spinal_n-1', ''),
    ('T5_spinal_n-2', ''),
    ('T5_spinal_n-3', ''),
    ('T5_ventral_root_paravertebral_ganglion', ''),
    ('T5_ventral_root_ramus', ''),
    ('T6_dorsal_root', ''),
    ('T6_gray_ramus-spinal_n', ''),
    ('T6_paravertebral_ganglion-ardell_5', ''),
    ('T6_spinal_n-1', ''),
    ('T6_spinal_n-2', ''),
    ('T6_spinal_n-3', ''),
    ('T6_ventral_root_paravertebral_ganglion', ''),
    ('T6_ventral_root_ramus', ''),
    ('T7_spinal_n-3', ''),
    ('T7_ventral_root_ramus', ''),
    ('T8_spinal_n-3', ''),
    ('T8_ventral_root_ramus', ''),
    ('T9_spinal_n-3', ''),
    ('T9_ventral_root_ramus', ''),
    ('ardell_1', ''),
    ('ardell_2', ''),
    ('ardell_3', ''),
    ('ardell_4', ''),
    ('ardell_5', ''),
    ('ardell_6', ''),
    ('bladder_n', ''),
    ('bolser_1', ''),
    ('bolser_10', ''),
    ('bolser_14', ''),
    ('bolser_15', ''),
    ('bolser_2', ''),
    ('bolser_9', ''),
    ('carotid sinus nerve', 'UBERON:0009009'),
    ('glossopharyngeal nerve', 'UBERON:0001649'),
    ('hypogastric_n', ''),
    ('hypoglossal nerve', 'UBERON:0001650'),
    ('lumbar_splanchnic_n', ''),
    ('n_1', ''),
    ('n_10', ''),
    ('n_11', ''),
    ('n_12', ''),
    ('n_13', ''),
    ('n_14', ''),
    ('n_15', ''),
    ('n_16', ''),
    ('n_17', ''),
    ('n_18', ''),
    ('n_19', ''),
    ('n_2', ''),
    ('n_20', ''),
    ('n_21', ''),
    ('n_22', ''),
    ('n_23', ''),
    ('n_24', ''),
    ('n_25', ''),
    ('n_26', ''),
    ('n_27', ''),
    ('n_28', ''),
    ('n_29', ''),
    ('n_3', ''),
    ('n_30', ''),
    ('n_31', ''),
    ('n_32', ''),
    ('n_33', ''),
    ('n_34', ''),
    ('n_35', ''),
    ('n_36', ''),
    ('n_37', ''),
    ('n_38', ''),
    ('n_39', ''),
    ('n_4', ''),
    ('n_40', ''),
    ('n_41', ''),
    ('n_42', ''),
    ('n_43', ''),
    ('n_44', ''),
    ('n_45', ''),
    ('n_46', ''),
    ('n_47', ''),
    ('n_48', ''),
    ('n_49', ''),
    ('n_5', ''),
    ('n_50', ''),
    ('n_51', ''),
    ('n_52', ''),
    ('n_53', ''),
    ('n_54', ''),
    ('n_55', ''),
    ('n_56', ''),
    ('n_57', ''),
    ('n_58', ''),
    ('n_59', ''),
    ('n_6', ''),
    ('n_60', ''),
    ('n_61', ''),
    ('n_62', ''),
    ('n_63', ''),
    ('n_64', ''),
    ('n_65', ''),
    ('n_66', ''),
    ('n_67', ''),
    ('n_68', ''),
    ('n_6_X', ''),
    ('n_7', ''),
    ('n_8', ''),
    ('n_9', ''),
    ('pelvic_splanchnic_n', ''),
    ('phrenic_n', ''),
    ('pudendal_n', ''),
    ('recurrent laryngeal nerve', 'UBERON:0003716'),
    ('splanchnic_n', ''),
    ('sympathetic_trunk_L1-L2', ''),
    ('sympathetic_trunk_L2-L3', ''),
    ('sympathetic_trunk_L3-L4', ''),
    ('sympathetic_trunk_L4-L5', ''),
    ('sympathetic_trunk_L5-L6', ''),
    ('sympathetic_trunk_L6-S1', ''),
    ('sympathetic_trunk_S1-S2', ''),
    ('sympathetic_trunk_T1-T2', ''),
    ('sympathetic_trunk_T11-T12', ''),
    ('sympathetic_trunk_T12-T13', ''),
    ('sympathetic_trunk_T13-L1', ''),
    ('sympathetic_trunk_T2-T3', ''),
    ('sympathetic_trunk_T3-T4', ''),
    ('sympathetic_trunk_T4-T5', ''),
    ('sympathetic_trunk_T5-T6', ''),
    ('sympathetic_trunk_T6-T7', ''),
    ('sympathetic_trunk_T7-T8', ''),
    ]


def get_nerve_term(name : str):
    """
    Find term by matching name to any identifier held for a term.
    Raise exception if name not found.
    :return ( preferred name, preferred id )
    """
    for term in nerve_terms:
        if name in term:
            return ( term[0], term[1] )
    raise NameError("Nerve annotation term '" + name + "' not found.")
